/***************************************
*                                      *
*   frmConnect Create & Events         *
*                                      *
***************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <math.h> 
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h> 
#include <string.h>
#include <unistd.h>

#include <gdk/gdkkeysyms.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>

#include <glib/gi18n.h>

#include "rdpfile.h"
#include "support.h"
#include "connect.h"
#include "mrulist.h"


/***************************************
*                                      *
*   frmConnect Create                  *
*                                      *
***************************************/

int 
create_frmConnect (void)
{
  gint i = 0;
  gchar *langlist[]={    "", "ar", "be", 
    "bg", "br", "cf", "ch", "common",
    "cz", "da", "de", "de-ch", "dk", "dv", 
    "en-gb", "en-us", "es", "et", "fi", 
    "fo", "fr", "fr-be", "fr-ca", "fr-ch", 
    "gk", "gr", "hr", "hu", "is", "it", 
    "ja", "ko", "la", "lt", "lv", "mk", 
    "nl", "no", "pl", "po", "pt", "pt-br",
    "ro", "ru", "sf", "sl", "sp", "su", 
    "sv", "th", "tr", "uk", "us", "usl", 
    "usr", "yu",
    NULL};
  gchar *size_items[] = {
    _("640 x 480 pixels"),
    _("800 x 600 pixels"),
    _("1024 x 768 pixels"),
    _("1152 x 864 pixels"),
    _("1280 x 960 pixels"),
    _("1400 x 1050 pixels"),
	  NULL
  };
  gchar *color_items[] = {
    _("256 Colors"),
    _("High Color (15 bit)"),
    _("High Color (16 bit)"),
    _("True Color (24 bit)"),
	  NULL
  };

  GtkWidget *frmConnect;
  
  GtkWidget *vbxComplete;
  GtkWidget *nbkComplete;
  GtkWidget *vbxCompact;

  GtkWidget *vbxMain;
  GtkWidget *vbxBanner;
  GtkWidget *imgBanner;
  const gchar *lang = (const gchar*)gtk_get_default_language();
  gchar *banner_lang;
  gchar *banner_lang_tmp;


  // Profile Launcher Widgets
  GtkWidget *hbxProfileLauncher;
  GtkWidget *optProfileLauncher;
  // Profile File Ops
  GtkWidget *hbxFileOps;
  GtkWidget *btnSaveAs;
  GtkWidget *btnOpen;

  // General Tab Widgets
  GtkWidget *lblGeneralTab1;
  GtkWidget *vbxGeneralTab1;

  // Logon Frame Widgets
  GtkWidget *frameLogon;
  GtkWidget *tblLogon0;
  GtkWidget *tblLogon1;
  GtkWidget *lblLogonFrame;
  GtkWidget *lblLogonNote;
  GtkWidget *imgGeneralLogon;
  GtkWidget *lblComputer;
  GtkWidget *cboComputer;
  GtkWidget *txtComputer;
  GtkWidget *lblProtocol;
  GtkWidget *optProtocol;
  GtkWidget *mnuProtocol;
  GtkWidget *lblUsername;
  GtkWidget *txtUsername;
  GtkWidget *lblPassword;
  GtkWidget *txtPassword;
  GtkWidget *lblDomain;
  GtkWidget *txtDomain;
  GtkWidget *lblClientHostname;
  GtkWidget *txtClientHostname;
  GtkWidget *lblProtoFile;
  GtkWidget *hbxProtoFile;
  GtkWidget *txtProtoFile;
  GtkWidget *btnProtoFile;

  // Display Tab Widgets
  GtkWidget *lblDisplayTab1;
  GtkWidget *vbxDisplayTab1;

  // Size Frame Widgets
  GtkWidget *frameSize;
  GtkWidget *lblSizeFrame;
  GtkWidget *vbxSize;
  GtkWidget *imgSize;
  GtkWidget *hbxSize;
  GtkWidget *optSize1;
  GtkWidget *optSize2;
  GtkWidget *optSize3;
  GtkWidget *alnSize;
  GtkWidget *optSize;
  GtkWidget *alnAltFullSwitch;
  GtkWidget *chkAltFullSwitch;

  // Color Frame Widgets
  GtkWidget *frameColor;
  GtkWidget *lblColorFrame;
  GtkWidget *hbxColor;
  GtkWidget *imgColor;
  GtkWidget *vbxColor;
  GtkWidget *optColor1;
  GtkWidget *optColor2;
  GtkWidget *alnColor;
  GtkWidget *optColor;

  // Local Resources Tab Widgets
  GtkWidget *lblLocalTab1;
  GtkWidget *vbxLocalTab1;

  // Sound Frame Widgets
  GtkWidget *frameSound;
  GtkWidget *lblSoundFrame;
  GtkWidget *tblSound;
  GtkWidget *imgSound;
  GtkWidget *vbxSound;
  GtkWidget *optSound1;
  GtkWidget *optSound2;
  GtkWidget *optSound3;

  // Keyboard Frame Widgets
  GtkWidget *frameKeyboard;
  GtkWidget *lblKeyboardFrame;
  GtkWidget *tblKeyboard;
  GtkWidget *lblKeyboard;
  GtkWidget *imgKeyboard;
  GtkWidget *optKeyboard;
  GtkWidget *mnuKeyboard;
  GtkWidget *miKeyboard;
  GtkWidget *lblKeyboardLang;
  GtkWidget *cboKeyboardLang;
  GtkWidget *txtKeyboardLang;

  // Program Tab Widgets
  GtkWidget *lblProgramsTab1;

  // Program Frame Widgets
  GtkWidget *frameProgram;
  GtkWidget *lblProgramFrame;
  GtkWidget *tblProgram;
  GtkWidget *chkStartProgram;
  GtkWidget *imgProgram;
  GtkWidget *lblProgramPath;
  GtkWidget *txtProgramPath;
  GtkWidget *lblStartFolder;
  GtkWidget *txtStartFolder;

  // Performance Tab Widgets
  GtkWidget *lblPerformanceTab1;

  // Performance Frame Widgets
  GtkWidget *framePerform;
  GtkWidget *lblPerformFrame;
  GtkWidget *tblPerform;
  GtkWidget *imgPerform;
  GtkWidget *lblPerformanceOptions;
  GtkWidget *vbxExpChecks;
  GtkWidget *chkDesktopBackground;
  GtkWidget *chkWindowContent;
  GtkWidget *chkAnimation;
  GtkWidget *chkThemes;
  GtkWidget *chkBitmapCache;
  GtkWidget *chkNoMotionEvents;
  GtkWidget *chkEnableWMKeys;
  GtkWidget *chkHideWMDecorations;
  GtkWidget *chkAttachToConsole;

  // Complete Button Box Widgets
  GtkWidget *hbbAppOps;
  GtkWidget *btnConnect;
  GtkWidget *alnConnect;
  GtkWidget *hbxConnect;
  GtkWidget *imgConnect;
  GtkWidget *lblConnect;
  GtkWidget *btnQuit;
  GtkWidget *btnHelp;

  // Protocol Menu Item Widget
  GtkWidget *miProtocol;

  GList *cboKeyboard_items = NULL;
  GSList *optSize1_group = NULL;
  GSList *optColor1_group = NULL;
  GSList *optSound1_group = NULL;

  GtkTooltips *tooltips;
  tooltips = gtk_tooltips_new ();

  #ifdef TSCLIENT_DEBUG
  printf ("create_frmConnect\n");
  #endif

  /*
    This is the main form
  */
  frmConnect = NULL;
  frmConnect = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (frmConnect), _("Terminal Server Client"));
  gtk_window_set_default_size (GTK_WINDOW (frmConnect), 405, -1);
  gtk_window_set_position (GTK_WINDOW (frmConnect), GTK_WIN_POS_CENTER);
  gtk_window_set_resizable (GTK_WINDOW (frmConnect), FALSE);
  gtk_window_set_destroy_with_parent (GTK_WINDOW (frmConnect), TRUE);
  gtk_window_set_icon (GTK_WINDOW (frmConnect), create_pixbuf ("tsclient.png"));
  
  /*
    This is the main container
  */
  vbxMain = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frmConnect), vbxMain);

  /*
    This is the banner at the top
  */
  vbxBanner = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbxMain), vbxBanner, TRUE, TRUE, 1);

  // try to find a localized banner image, use -en on fail
  banner_lang = g_strdup_printf ("banner-%s.png", g_strndup ((!lang)?"en":lang,2));
  if (strcmp (banner_lang, "banner-c.png") == 0) {
    banner_lang = g_strdup ("banner-en.png");
  } else {
    if (!find_pixmap_file (banner_lang)) {
      banner_lang = g_strdup_printf ("banner-%s.png", g_strndup ((!lang)?"en_US":lang,5));
      if (!find_pixmap_file (banner_lang)) {
        banner_lang = g_strdup ("banner-en.png");
      }
    }
  }
  imgBanner = create_pixmap (frmConnect, banner_lang);
  g_free (banner_lang);
  gtk_box_pack_start (GTK_BOX (vbxBanner), imgBanner, FALSE, TRUE, 0);
  gtk_misc_set_alignment (GTK_MISC (imgBanner), 0.5, 0);

  /*
    This is the complete container
  */
  vbxComplete = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbxMain), vbxComplete, TRUE, TRUE, 0);


  /*
    This is the label for the Connection Profile
  lblConnectionProfile = gtk_label_new (_("Connection Profile"));
  gtk_widget_set_name (lblConnectionProfile, "lblConnectionProfile");
  gtk_label_set_markup (GTK_LABEL (lblConnectionProfile), g_strconcat ("<span weight=\"bold\">", _("Connection Profile"), "</span>", NULL));
  gtk_label_set_justify (GTK_LABEL (lblConnectionProfile), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblConnectionProfile), 0, 0.5);
  gtk_box_pack_start (GTK_BOX (vbxComplete), lblConnectionProfile, TRUE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (lblConnectionProfile), 6, 3);
  */


  /*
    This is the notebook for the Complete mode
  */
  nbkComplete = gtk_notebook_new ();
  gtk_box_pack_start (GTK_BOX (vbxComplete), nbkComplete, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (nbkComplete), 6);
  gtk_notebook_set_show_border (GTK_NOTEBOOK (nbkComplete), FALSE);

  vbxGeneralTab1 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (nbkComplete), vbxGeneralTab1);
  gtk_notebook_set_tab_label_packing (GTK_NOTEBOOK (nbkComplete), vbxGeneralTab1,
                                      TRUE, TRUE, GTK_PACK_START);
                                      

  frameLogon = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbxGeneralTab1), frameLogon, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frameLogon), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frameLogon), GTK_SHADOW_NONE);

  lblLogonFrame = gtk_label_new (_("Logon Settings"));
  gtk_label_set_markup (GTK_LABEL (lblLogonFrame), g_strconcat ("<span weight=\"bold\">", _("Logon Settings"), "</span>", NULL));
  gtk_frame_set_label_widget (GTK_FRAME (frameLogon), lblLogonFrame);
  gtk_label_set_justify (GTK_LABEL (lblLogonFrame), GTK_JUSTIFY_LEFT);

  tblLogon0 = gtk_table_new (2, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (frameLogon), tblLogon0);

  lblLogonNote = gtk_label_new (_("Type the name of the computer or choose a computer from the drop-down list."));
  gtk_table_attach (GTK_TABLE (tblLogon0), lblLogonNote, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (lblLogonNote), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (lblLogonNote), TRUE);
  gtk_misc_set_alignment (GTK_MISC (lblLogonNote), 0, 0.5);

  imgGeneralLogon = create_pixmap (frmConnect, "computer.png");
  gtk_table_attach (GTK_TABLE (tblLogon0), imgGeneralLogon, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_padding (GTK_MISC (imgGeneralLogon), 3, 3);

  tblLogon1 = gtk_table_new (6, 2, FALSE);
  gtk_table_attach (GTK_TABLE (tblLogon0), tblLogon1, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_table_set_row_spacings (GTK_TABLE (tblLogon1), 4);
  gtk_table_set_col_spacings (GTK_TABLE (tblLogon1), 4);

  lblComputer = gtk_label_new_with_mnemonic (_("Compu_ter:"));
  gtk_table_attach (GTK_TABLE (tblLogon1), lblComputer, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 6, 6);
  gtk_label_set_justify (GTK_LABEL (lblComputer), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblComputer), 0, 0.5);

  lblProtocol = gtk_label_new_with_mnemonic (_("Pro_tocol:"));
  gtk_table_attach (GTK_TABLE (tblLogon1), lblProtocol, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 6, 6);
  gtk_label_set_justify (GTK_LABEL (lblProtocol), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblProtocol), 0, 0.5);

  lblUsername = gtk_label_new_with_mnemonic (_("_User Name:"));
  gtk_table_attach (GTK_TABLE (tblLogon1), lblUsername, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 6, 6);
  gtk_label_set_justify (GTK_LABEL (lblUsername), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblUsername), 0, 0.5);

  lblPassword = gtk_label_new_with_mnemonic (_("Pass_word:"));
  gtk_table_attach (GTK_TABLE (tblLogon1), lblPassword, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 6, 6);
  gtk_label_set_justify (GTK_LABEL (lblPassword), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblPassword), 0, 0.5);

  lblDomain = gtk_label_new_with_mnemonic (_("Do_main:"));
  gtk_table_attach (GTK_TABLE (tblLogon1), lblDomain, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 6, 6);
  gtk_label_set_justify (GTK_LABEL (lblDomain), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblDomain), 0, 0.5);

  lblClientHostname = gtk_label_new_with_mnemonic (_("C_lient Hostname:"));
  gtk_table_attach (GTK_TABLE (tblLogon1), lblClientHostname, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 6, 6);
  gtk_label_set_justify (GTK_LABEL (lblClientHostname), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblClientHostname), 0, 0.5);

  lblProtoFile = gtk_label_new_with_mnemonic (_("Prot_ocol File:"));
  gtk_table_attach (GTK_TABLE (tblLogon1), lblProtoFile, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 6, 6);
  gtk_label_set_justify (GTK_LABEL (lblProtoFile), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblProtoFile), 0, 0.5);

  cboComputer = gtk_combo_new ();
  g_object_set_data (G_OBJECT (GTK_COMBO (cboComputer)->popwin),
                       "GladeParentKey", cboComputer);
  gtk_combo_set_value_in_list (GTK_COMBO (cboComputer), FALSE, FALSE);
  gtk_table_attach (GTK_TABLE (tblLogon1), cboComputer, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txtComputer = GTK_COMBO (cboComputer)->entry;
  gtk_entry_set_activates_default (GTK_ENTRY (txtComputer), TRUE);
  gtk_tooltips_set_tip (tooltips, txtComputer, _("Enter the name or address of the remote system."), NULL);

  optProtocol = gtk_option_menu_new ();
  gtk_table_attach (GTK_TABLE (tblLogon1), optProtocol, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, optProtocol, _("Select the protocol to use for this connection."), NULL);

  mnuProtocol = gtk_menu_new ();

  miProtocol = gtk_menu_item_new_with_mnemonic ("RDP");
  gtk_container_add (GTK_CONTAINER (mnuProtocol), miProtocol);
  gtk_tooltips_set_tip (tooltips, miProtocol, _("RDP protocol is used to connect to Microsoft Windows 2000 and older systems."), NULL);
  g_signal_connect (G_OBJECT (miProtocol), "activate", G_CALLBACK (on_protocol_changed), (int*)0);
  gtk_widget_ref (miProtocol);
  if (!g_find_program_in_path ("rdesktop")) { gtk_widget_set_sensitive (miProtocol, FALSE); }

  miProtocol = gtk_menu_item_new_with_mnemonic ("RDPv5");
  gtk_container_add (GTK_CONTAINER (mnuProtocol), miProtocol);
  gtk_tooltips_set_tip (tooltips, miProtocol, _("RDPv5 protocol is used to connect to Microsoft Windows XP and newer systems."), NULL);
  g_signal_connect (G_OBJECT (miProtocol), "activate", G_CALLBACK (on_protocol_changed), (int*)4);
  gtk_widget_ref (miProtocol);
  if (!g_find_program_in_path ("rdesktop")) { gtk_widget_set_sensitive (miProtocol, FALSE); }

  miProtocol = gtk_menu_item_new_with_mnemonic ("VNC");
  gtk_container_add (GTK_CONTAINER (mnuProtocol), miProtocol);
  gtk_tooltips_set_tip (tooltips, miProtocol, _("VNC protocol is used to connect to systems sharing the desktop by using VNC."), NULL);
  g_signal_connect (G_OBJECT (miProtocol), "activate", G_CALLBACK (on_protocol_changed), (int*)1);
  gtk_widget_ref (miProtocol);
  if (!g_find_program_in_path ("vncviewer") &&
      !g_find_program_in_path ("xvncviewer") &&
      !g_find_program_in_path ("xtightvncviewer") &&
      !g_find_program_in_path ("svncviewer") )
    { gtk_widget_set_sensitive (miProtocol, FALSE); }
    
  miProtocol = gtk_menu_item_new_with_mnemonic ("XDMCP");
  gtk_container_add (GTK_CONTAINER (mnuProtocol), miProtocol);
  gtk_tooltips_set_tip (tooltips, miProtocol, _("XDMCP protocol uses Xnest to connect to servers running X."), NULL);
  g_signal_connect (G_OBJECT (miProtocol), "activate", G_CALLBACK (on_protocol_changed), (int*)2);
  gtk_widget_ref (miProtocol);
  if (!g_find_program_in_path ("Xnest")) { gtk_widget_set_sensitive (miProtocol, FALSE); }

  miProtocol = gtk_menu_item_new_with_mnemonic ("ICA");
  gtk_container_add (GTK_CONTAINER (mnuProtocol), miProtocol);
  gtk_tooltips_set_tip (tooltips, miProtocol, _("ICA protocol is used to connect to Citrix servers."), NULL);
  g_signal_connect (G_OBJECT (miProtocol), "activate", G_CALLBACK (on_protocol_changed), (int*)3);
  gtk_widget_ref (miProtocol);
  if (!g_find_program_in_path ("wfica") &&
      !g_file_test ("/usr/lib/ICAClient/wfica", G_FILE_TEST_EXISTS) )
    { gtk_widget_set_sensitive (miProtocol, FALSE); }

  gtk_option_menu_set_menu (GTK_OPTION_MENU (optProtocol), mnuProtocol);


  txtUsername = gtk_entry_new ();
  gtk_entry_set_activates_default (GTK_ENTRY (txtUsername), TRUE);
  gtk_table_attach (GTK_TABLE (tblLogon1), txtUsername, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, txtUsername, _("Enter the username for the remote system.\nFor VNC, enter the path to your saved vnc password file."), NULL);

  txtPassword = gtk_entry_new ();
  gtk_entry_set_activates_default (GTK_ENTRY (txtPassword), TRUE);
  gtk_table_attach (GTK_TABLE (tblLogon1), txtPassword, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (txtPassword), FALSE);
  gtk_tooltips_set_tip (tooltips, txtPassword, _("Enter the password for the remote system."), NULL);

  txtDomain = gtk_entry_new ();
  gtk_entry_set_activates_default (GTK_ENTRY (txtDomain), TRUE);
  gtk_table_attach (GTK_TABLE (tblLogon1), txtDomain, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, txtDomain, _("Enter the domain for the remote system."), NULL);

  txtClientHostname = gtk_entry_new ();
  gtk_entry_set_activates_default (GTK_ENTRY (txtClientHostname), TRUE);
  gtk_table_attach (GTK_TABLE (tblLogon1), txtClientHostname, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, txtClientHostname, _("Enter the local hostname for this system."), NULL);

  hbxProtoFile = gtk_hbox_new (FALSE, 2);
  gtk_table_attach (GTK_TABLE (tblLogon1), hbxProtoFile, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txtProtoFile = gtk_entry_new ();
  gtk_entry_set_activates_default (GTK_ENTRY (txtProtoFile), TRUE);
  gtk_box_pack_start (GTK_BOX (hbxProtoFile), txtProtoFile, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, txtProtoFile, _("Some protocols require a file containing settings. If required, enter the path to the file here."), NULL);

  btnProtoFile = gtk_button_new_with_label ("...");
  gtk_container_add (GTK_CONTAINER (hbxProtoFile), btnProtoFile);


  vbxDisplayTab1 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (nbkComplete), vbxDisplayTab1);
  gtk_notebook_set_tab_label_packing (GTK_NOTEBOOK (nbkComplete), vbxDisplayTab1,
                                      TRUE, TRUE, GTK_PACK_START);

  frameSize = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbxDisplayTab1), frameSize, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frameSize), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frameSize), GTK_SHADOW_NONE);

  lblSizeFrame = gtk_label_new (_("Remote Desktop Size"));
  gtk_label_set_markup (GTK_LABEL (lblSizeFrame), g_strconcat ("<span weight=\"bold\">", _("Remote Desktop Size"), "</span>", NULL));
  gtk_frame_set_label_widget (GTK_FRAME (frameSize), lblSizeFrame);
  gtk_label_set_justify (GTK_LABEL (lblSizeFrame), GTK_JUSTIFY_LEFT);

  hbxSize = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frameSize), hbxSize);

  imgSize = create_pixmap (frmConnect, "size.png");
  gtk_box_pack_start (GTK_BOX (hbxSize), imgSize, FALSE, TRUE, 0);
  gtk_misc_set_alignment (GTK_MISC (imgSize), 0, 0);
  gtk_misc_set_padding (GTK_MISC (imgSize), 3, 3);

  vbxSize = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbxSize), vbxSize, TRUE, TRUE, 0);

  optSize1 = gtk_radio_button_new_with_mnemonic (NULL, _("Use default screen size"));
  gtk_box_pack_start (GTK_BOX (vbxSize), optSize1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optSize1), 3);
  gtk_tooltips_set_tip (tooltips, optSize1, _("Use the default screen size."), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optSize1), optSize1_group);
  optSize1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optSize1));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (optSize1), TRUE);

  optSize2 = gtk_radio_button_new_with_mnemonic (NULL, _("Use specified screen size"));
  gtk_box_pack_start (GTK_BOX (vbxSize), optSize2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optSize2), 3);
  gtk_tooltips_set_tip (tooltips, optSize2, _("Use the list to choose the screen size to use."), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optSize2), optSize1_group);
  optSize1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optSize2));

  alnSize = gtk_alignment_new (0.5, 0.5, 0.88, 1);
  gtk_box_pack_start (GTK_BOX (vbxSize), alnSize, FALSE, TRUE, 0);

  optSize = tsc_option_menu_factory (size_items);
  gtk_container_add (GTK_CONTAINER (alnSize), optSize);

  optSize3 = gtk_radio_button_new_with_mnemonic (NULL, _("Operate in full screen mode"));
  gtk_box_pack_start (GTK_BOX (vbxSize), optSize3, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optSize3), 3);
  gtk_tooltips_set_tip (tooltips, optSize3, _("Work in full screen mode."), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optSize3), optSize1_group);
  optSize1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optSize3));

  alnAltFullSwitch = gtk_alignment_new (0.5, 0.5, 0.88, 1);
  gtk_box_pack_start (GTK_BOX (vbxSize), alnAltFullSwitch, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (alnAltFullSwitch, FALSE);

  chkAltFullSwitch = gtk_check_button_new_with_mnemonic (_("Use alternate full screen switch (-F)"));
  gtk_container_add (GTK_CONTAINER (alnAltFullSwitch), chkAltFullSwitch);
  gtk_container_set_border_width (GTK_CONTAINER (chkAltFullSwitch), 3);
  gtk_tooltips_set_tip (tooltips, chkAltFullSwitch, _("Check this if you use rdesktop with the unified patches."), NULL);


  frameColor = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbxDisplayTab1), frameColor, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frameColor), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frameColor), GTK_SHADOW_NONE);

  lblColorFrame = gtk_label_new (_("Colors"));
  gtk_label_set_markup (GTK_LABEL (lblColorFrame), g_strconcat ("<span weight=\"bold\">", _("Colors"), "</span>", NULL));
  gtk_frame_set_label_widget (GTK_FRAME (frameColor), lblColorFrame);
  gtk_label_set_justify (GTK_LABEL (lblColorFrame), GTK_JUSTIFY_LEFT);

  hbxColor = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frameColor), hbxColor);

  imgColor = create_pixmap (frmConnect, "colors.png");
  gtk_box_pack_start (GTK_BOX (hbxColor), imgColor, FALSE, TRUE, 0);
  gtk_misc_set_alignment (GTK_MISC (imgColor), 0, 0);
  gtk_misc_set_padding (GTK_MISC (imgColor), 3, 3);

  vbxColor = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbxColor), vbxColor, TRUE, TRUE, 0);

  optColor1 = gtk_radio_button_new_with_mnemonic (NULL, _("Use default color depth"));
  gtk_box_pack_start (GTK_BOX (vbxColor), optColor1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optColor1), 3);
  gtk_tooltips_set_tip (tooltips, optColor1, _("Use the default color depth."), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optColor1), optColor1_group);
  optColor1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optColor1));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (optColor1), TRUE);

  optColor2 = gtk_radio_button_new_with_mnemonic (NULL, _("Use specified color depth"));
  gtk_box_pack_start (GTK_BOX (vbxColor), optColor2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optColor2), 3);
  gtk_tooltips_set_tip (tooltips, optColor2, _("Use the list to choose the color depth to use."), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optColor2), optColor1_group);
  optColor1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optColor2));

  alnColor = gtk_alignment_new (0.5, 0.5, 0.88, 1);
  gtk_box_pack_start (GTK_BOX (vbxColor), alnColor, FALSE, TRUE, 0);

  optColor = tsc_option_menu_factory (color_items);
  gtk_container_add (GTK_CONTAINER (alnColor), optColor);

  vbxLocalTab1 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (nbkComplete), vbxLocalTab1);
  gtk_notebook_set_tab_label_packing (GTK_NOTEBOOK (nbkComplete), vbxLocalTab1,
                                      TRUE, TRUE, GTK_PACK_START);

  frameSound = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbxLocalTab1), frameSound, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frameSound), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frameSound), GTK_SHADOW_NONE);

  lblSoundFrame = gtk_label_new_with_mnemonic (_("Remote Computer _Sound"));
  gtk_label_set_markup (GTK_LABEL (lblSoundFrame), g_strconcat ("<span weight=\"bold\">", _("Remote Computer Sound"), "</span>", NULL));
  gtk_frame_set_label_widget (GTK_FRAME (frameSound), lblSoundFrame);
  gtk_label_set_justify (GTK_LABEL (lblSoundFrame), GTK_JUSTIFY_LEFT);

  tblSound = gtk_table_new (1, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (frameSound), tblSound);
  gtk_table_set_col_spacings (GTK_TABLE (tblSound), 6);

  imgSound = create_pixmap (frmConnect, "sound.png");
  gtk_misc_set_padding (GTK_MISC (imgSound), 3, 3);
  gtk_table_attach (GTK_TABLE (tblSound), imgSound, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) 0, 0, 0);

  vbxSound = gtk_vbox_new (FALSE, 0);
  gtk_table_attach (GTK_TABLE (tblSound), vbxSound, 1, 2, 0, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  optSound1 = gtk_radio_button_new_with_mnemonic (NULL, _("On the local computer"));
  gtk_box_pack_start (GTK_BOX (vbxSound), optSound1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optSound1), 3);
  gtk_tooltips_set_tip (tooltips, optSound1, _("On the local computer"), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optSound1), optSound1_group);
  optSound1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optSound1));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (optSound1), TRUE);

  optSound2 = gtk_radio_button_new_with_mnemonic (NULL, _("On the remote computer"));
  gtk_box_pack_start (GTK_BOX (vbxSound), optSound2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optSound2), 3);
  gtk_tooltips_set_tip (tooltips, optSound2, _("On the remote computer"), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optSound2), optSound1_group);
  optSound1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optSound2));

  optSound3 = gtk_radio_button_new_with_mnemonic (NULL, _("Do not play"));
  gtk_box_pack_start (GTK_BOX (vbxSound), optSound3, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (optSound3), 3);
  gtk_tooltips_set_tip (tooltips, optSound3, _("Do not play"), NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (optSound3), optSound1_group);
  optSound1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (optSound3));


  frameKeyboard = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbxLocalTab1), frameKeyboard, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frameKeyboard), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frameKeyboard), GTK_SHADOW_NONE);

  lblKeyboardFrame = gtk_label_new_with_mnemonic (_("_Keyboard"));
  gtk_label_set_markup (GTK_LABEL (lblKeyboardFrame), g_strconcat ("<span weight=\"bold\">", _("Keyboard"), "</span>", NULL));
  gtk_frame_set_label_widget (GTK_FRAME (frameKeyboard), lblKeyboardFrame);
  gtk_label_set_justify (GTK_LABEL (lblKeyboardFrame), GTK_JUSTIFY_LEFT);

  tblKeyboard = gtk_table_new (2, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (frameKeyboard), tblKeyboard);
  gtk_table_set_col_spacings (GTK_TABLE (tblKeyboard), 6);

  optKeyboard = gtk_option_menu_new ();
  gtk_table_attach (GTK_TABLE (tblKeyboard), optKeyboard, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  mnuKeyboard = gtk_menu_new ();

  miKeyboard = gtk_menu_item_new_with_mnemonic (_("On the local computer"));
  gtk_container_add (GTK_CONTAINER (mnuKeyboard), miKeyboard);

  miKeyboard = gtk_menu_item_new_with_mnemonic (_("On the remote computer"));
  gtk_container_add (GTK_CONTAINER (mnuKeyboard), miKeyboard);

  miKeyboard = gtk_menu_item_new_with_mnemonic (_("In full screen mode only"));
  gtk_container_add (GTK_CONTAINER (mnuKeyboard), miKeyboard);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (optKeyboard), mnuKeyboard);


  lblKeyboardLang = gtk_label_new (_("Use the following keyboard language\n(2 char keycode)"));
  gtk_table_attach (GTK_TABLE (tblKeyboard), lblKeyboardLang, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (lblKeyboardLang), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblKeyboardLang), 0, 0.5);

  cboKeyboardLang = gtk_combo_new ();
  g_object_set_data ( G_OBJECT ( GTK_COMBO ( cboKeyboardLang)->popwin ),
		     "GladeParentLangKey", cboKeyboardLang );
  gtk_table_attach (GTK_TABLE (tblKeyboard), cboKeyboardLang, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  cboKeyboard_items = NULL;
  i = 0;
  while(langlist[i]){
    cboKeyboard_items = g_list_append (cboKeyboard_items, (gpointer) langlist[i]);
	  i++;
  }
  gtk_combo_set_popdown_strings (GTK_COMBO (cboKeyboardLang), cboKeyboard_items);
  g_list_free (cboKeyboard_items);  

  txtKeyboardLang = GTK_COMBO (cboKeyboardLang)->entry;

  lblKeyboard = gtk_label_new (_("Apply Windows key combinations\n(for example ALT+TAB) (unsupported)"));
  gtk_table_attach (GTK_TABLE (tblKeyboard), lblKeyboard, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (lblKeyboard), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblKeyboard), 0, 0.5);

  imgKeyboard = create_pixmap (frmConnect, "keyboard.png");
  gtk_table_attach (GTK_TABLE (tblKeyboard), imgKeyboard, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) 0, 0, 0);
  gtk_misc_set_padding (GTK_MISC (imgKeyboard), 3, 3);

  frameProgram = gtk_frame_new (NULL);
  gtk_container_add (GTK_CONTAINER (nbkComplete), frameProgram);
  gtk_notebook_set_tab_label_packing (GTK_NOTEBOOK (nbkComplete), frameProgram,
                                      TRUE, TRUE, GTK_PACK_START);
  gtk_container_set_border_width (GTK_CONTAINER (frameProgram), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frameProgram), GTK_SHADOW_NONE);

  lblProgramFrame = gtk_label_new (_("Start a Program"));
  gtk_label_set_markup (GTK_LABEL (lblProgramFrame), g_strconcat ("<span weight=\"bold\">", _("Start a Program"), "</span>", NULL));
  gtk_frame_set_label_widget (GTK_FRAME (frameProgram), lblProgramFrame);
  gtk_label_set_justify (GTK_LABEL (lblProgramFrame), GTK_JUSTIFY_LEFT);

  tblProgram = gtk_table_new (2, 5, FALSE);
  gtk_container_add (GTK_CONTAINER (frameProgram), tblProgram);

  imgProgram = create_pixmap (frmConnect, "program.png");
  gtk_table_attach (GTK_TABLE (tblProgram), imgProgram, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_misc_set_padding (GTK_MISC (imgProgram), 3, 3);

  chkStartProgram = gtk_check_button_new_with_mnemonic (_("Start the following program on connection"));
  gtk_table_attach (GTK_TABLE (tblProgram), chkStartProgram, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (chkStartProgram), 3);

  lblProgramPath = gtk_label_new (_("Program path and filename"));
  gtk_table_attach (GTK_TABLE (tblProgram), lblProgramPath, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (lblProgramPath), GTK_JUSTIFY_LEFT);

  txtProgramPath = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (tblProgram), txtProgramPath, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  lblStartFolder = gtk_label_new (_("Start in the following folder"));
  gtk_table_attach (GTK_TABLE (tblProgram), lblStartFolder, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (lblStartFolder), GTK_JUSTIFY_LEFT);

  txtStartFolder = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (tblProgram), txtStartFolder, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);


  framePerform = gtk_frame_new (NULL);
  gtk_container_add (GTK_CONTAINER (nbkComplete), framePerform);
  gtk_notebook_set_tab_label_packing (GTK_NOTEBOOK (nbkComplete), framePerform,
                                      TRUE, TRUE, GTK_PACK_START);
  gtk_container_set_border_width (GTK_CONTAINER (framePerform), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (framePerform), GTK_SHADOW_NONE);

  lblPerformFrame = gtk_label_new (_("Optimize Performance"));
  gtk_label_set_markup (GTK_LABEL (lblPerformFrame), g_strconcat ("<span weight=\"bold\">", _("Optimize Performance"), "</span>", NULL));
  gtk_frame_set_label_widget (GTK_FRAME (framePerform), lblPerformFrame);
  gtk_label_set_justify (GTK_LABEL (lblPerformFrame), GTK_JUSTIFY_LEFT);

  tblPerform = gtk_table_new (2, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (framePerform), tblPerform);

  imgPerform = create_pixmap (frmConnect, "perform.png");
  gtk_table_attach (GTK_TABLE (tblPerform), imgPerform, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_misc_set_padding (GTK_MISC (imgPerform), 3, 3);

  vbxExpChecks = gtk_vbox_new (FALSE, 0);
  gtk_table_attach (GTK_TABLE (tblPerform), vbxExpChecks, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  chkDesktopBackground = gtk_check_button_new_with_mnemonic (_("Desktop background (u)"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkDesktopBackground, FALSE, FALSE, 0);

  chkWindowContent = gtk_check_button_new_with_mnemonic (_("Show content of window while dragging (u)"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkWindowContent, FALSE, FALSE, 0);

  chkAnimation = gtk_check_button_new_with_mnemonic (_("Menu and window animation (u)"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkAnimation, FALSE, FALSE, 0);

  chkThemes = gtk_check_button_new_with_mnemonic (_("Themes (u)"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkThemes, FALSE, FALSE, 0);

  chkBitmapCache = gtk_check_button_new_with_mnemonic (_("Enable bitmap caching"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkBitmapCache, FALSE, FALSE, 0);

  chkNoMotionEvents = gtk_check_button_new_with_mnemonic (_("Do not send motion events"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkNoMotionEvents, FALSE, FALSE, 0);

  chkEnableWMKeys = gtk_check_button_new_with_mnemonic (_("Enable window manager's key bindings"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkEnableWMKeys, FALSE, FALSE, 0);

  chkHideWMDecorations = gtk_check_button_new_with_mnemonic (_("Hide window manager's decorations"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkHideWMDecorations, FALSE, FALSE, 0);

  chkAttachToConsole = gtk_check_button_new_with_mnemonic (_("Attach to console"));
  gtk_box_pack_start (GTK_BOX (vbxExpChecks), chkAttachToConsole, FALSE, FALSE, 0);


  lblPerformanceOptions = gtk_label_new (_("Options available for optimizing performance"));
  gtk_table_attach (GTK_TABLE (tblPerform), lblPerformanceOptions, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (lblPerformanceOptions), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (lblPerformanceOptions), TRUE);
  gtk_misc_set_alignment (GTK_MISC (lblPerformanceOptions), 0, 0.5);

  /*
    These are the labels for the notebook control
  */

  lblGeneralTab1 = gtk_label_new_with_mnemonic (_("_General"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (nbkComplete), gtk_notebook_get_nth_page (GTK_NOTEBOOK (nbkComplete), 0), lblGeneralTab1);
  gtk_label_set_justify (GTK_LABEL (lblGeneralTab1), GTK_JUSTIFY_LEFT);

  lblDisplayTab1 = gtk_label_new_with_mnemonic (_("_Display"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (nbkComplete), gtk_notebook_get_nth_page (GTK_NOTEBOOK (nbkComplete), 1), lblDisplayTab1);
  gtk_label_set_justify (GTK_LABEL (lblDisplayTab1), GTK_JUSTIFY_LEFT);

  lblLocalTab1 = gtk_label_new_with_mnemonic (_("Local _Resources"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (nbkComplete), gtk_notebook_get_nth_page (GTK_NOTEBOOK (nbkComplete), 2), lblLocalTab1);
  gtk_label_set_justify (GTK_LABEL (lblLocalTab1), GTK_JUSTIFY_LEFT);

  lblProgramsTab1 = gtk_label_new_with_mnemonic (_("_Programs"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (nbkComplete), gtk_notebook_get_nth_page (GTK_NOTEBOOK (nbkComplete), 3), lblProgramsTab1);
  gtk_label_set_justify (GTK_LABEL (lblProgramsTab1), GTK_JUSTIFY_LEFT);

  lblPerformanceTab1 = gtk_label_new_with_mnemonic (_("Perf_ormance"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (nbkComplete), gtk_notebook_get_nth_page (GTK_NOTEBOOK (nbkComplete), 4), lblPerformanceTab1);
  gtk_label_set_justify (GTK_LABEL (lblPerformanceTab1), GTK_JUSTIFY_LEFT);

  gtk_label_set_mnemonic_widget (GTK_LABEL (lblComputer), txtComputer);
  gtk_label_set_mnemonic_widget (GTK_LABEL (lblProtocol), optProtocol);
  gtk_label_set_mnemonic_widget (GTK_LABEL (lblUsername), txtUsername);
  gtk_label_set_mnemonic_widget (GTK_LABEL (lblPassword), txtPassword);
  gtk_label_set_mnemonic_widget (GTK_LABEL (lblDomain), txtDomain);
  gtk_label_set_mnemonic_widget (GTK_LABEL (lblClientHostname), txtClientHostname);
  gtk_label_set_mnemonic_widget (GTK_LABEL (lblProtoFile), txtProtoFile);


  /*
    This is the Profile Launcher
  */
  hbxProfileLauncher = gtk_hbox_new (FALSE, 3);
  gtk_box_pack_start (GTK_BOX (vbxComplete), hbxProfileLauncher, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbxProfileLauncher), 6);
  gtk_box_set_spacing (GTK_BOX (hbxProfileLauncher), 6);

  GtkWidget *event = gtk_event_box_new ();
  gtk_tooltips_set_tip (tooltips, event, _("Select a saved profile to launch it immediately."), NULL);
  gtk_box_pack_start (GTK_BOX (hbxProfileLauncher), event, TRUE, TRUE, 0);

  optProfileLauncher = gtk_combo_box_new_text();
  gtk_combo_box_append_text (GTK_COMBO_BOX(optProfileLauncher), _("Quick Connect"));
  gtk_combo_box_set_active (GTK_COMBO_BOX(optProfileLauncher), 0);
  g_signal_connect (G_OBJECT (optProfileLauncher), "changed", G_CALLBACK (tsc_quick_pick_activate), NULL);
  gtk_container_add (GTK_CONTAINER (event), optProfileLauncher);

  hbxFileOps = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbxProfileLauncher), hbxFileOps, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbxFileOps), 0);
  gtk_box_set_spacing (GTK_BOX (hbxFileOps), 6);

  btnOpen = gtk_button_new_from_stock (GTK_STOCK_OPEN);
  gtk_box_pack_start (GTK_BOX (hbxFileOps), btnOpen, TRUE, TRUE, 0);

  btnSaveAs = gtk_button_new_from_stock (GTK_STOCK_SAVE_AS);
  gtk_box_pack_start (GTK_BOX (hbxFileOps), btnSaveAs, TRUE, TRUE, 0);


  /*
    This is the button box for the Complete mode
  */

  hbbAppOps = gtk_hbutton_box_new ();
  gtk_box_pack_start (GTK_BOX (vbxComplete), hbbAppOps, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbbAppOps), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbbAppOps), 6);
  gtk_container_set_border_width (GTK_CONTAINER (hbbAppOps), 6);

  btnHelp = gtk_button_new_from_stock (GTK_STOCK_ABOUT);
  gtk_container_add (GTK_CONTAINER (hbbAppOps), btnHelp);

  btnQuit = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
  gtk_container_add (GTK_CONTAINER (hbbAppOps), btnQuit);

  btnConnect = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbbAppOps), btnConnect);
  GTK_WIDGET_SET_FLAGS (btnConnect, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(btnConnect);


  alnConnect = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_container_add (GTK_CONTAINER (btnConnect), alnConnect);

  hbxConnect = gtk_hbox_new (FALSE, 2);
  gtk_container_add (GTK_CONTAINER (alnConnect), hbxConnect);

  imgConnect = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_box_pack_start (GTK_BOX (hbxConnect), imgConnect, FALSE, FALSE, 0);

  lblConnect = gtk_label_new_with_mnemonic (_("Co_nnect"));
  gtk_box_pack_start (GTK_BOX (hbxConnect), lblConnect, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (lblConnect), GTK_JUSTIFY_LEFT);


  g_signal_connect (G_OBJECT (frmConnect), "destroy_event",
                    G_CALLBACK (gtk_main_quit),
                    NULL);
  g_signal_connect (G_OBJECT (frmConnect), "delete_event",
                    G_CALLBACK (gtk_main_quit),
                    NULL);
  g_signal_connect (G_OBJECT (btnConnect), "clicked",
                    G_CALLBACK (on_btnConnect_clicked),
                    NULL);
  g_signal_connect (G_OBJECT (btnQuit), "clicked",
                    G_CALLBACK (on_btnQuit_clicked),
                    NULL);
  g_signal_connect (G_OBJECT (btnHelp), "clicked",
                    G_CALLBACK (on_btnHelp_clicked),
                    NULL);

  g_signal_connect (G_OBJECT (optSize1), "clicked",
                    G_CALLBACK (on_optSize1_clicked),
                    NULL);
  g_signal_connect (G_OBJECT (optSize2), "clicked",
                    G_CALLBACK (on_optSize2_clicked),
                    NULL);
  g_signal_connect (G_OBJECT (optSize3), "clicked",
                    G_CALLBACK (on_optSize3_clicked),
                    NULL);

  g_signal_connect (G_OBJECT (optColor1), "clicked",
                    G_CALLBACK (on_optColor1_clicked),
                    NULL);
  g_signal_connect (G_OBJECT (optColor2), "clicked",
                    G_CALLBACK (on_optColor2_clicked),
                    NULL);

  g_signal_connect (G_OBJECT (btnSaveAs), "clicked",
                    G_CALLBACK (on_btnSaveAs_clicked),
                    NULL);
  g_signal_connect (G_OBJECT (btnOpen), "clicked",
                    G_CALLBACK (on_btnOpen_clicked),
                    NULL);
  g_signal_connect (G_OBJECT (btnProtoFile), "clicked",
                    G_CALLBACK (on_btnProtoFile_clicked),
                    NULL);

  g_signal_connect (G_OBJECT (chkStartProgram), "toggled",
                    G_CALLBACK (on_chkStartProgram_toggled),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  g_object_set_data (G_OBJECT (frmConnect), "frmConnect", frmConnect);

  HOOKUP_OBJECT (frmConnect, vbxComplete, "vbxComplete");
  HOOKUP_OBJECT (frmConnect, nbkComplete, "nbkComplete");

  HOOKUP_OBJECT (frmConnect, vbxMain, "vbxMain");
  HOOKUP_OBJECT (frmConnect, vbxBanner, "vbxBanner");
  HOOKUP_OBJECT (frmConnect, imgBanner, "imgBanner");

  // General Tab Widgets
  HOOKUP_OBJECT (frmConnect, lblGeneralTab1, "lblGeneralTab1");
  HOOKUP_OBJECT (frmConnect, vbxGeneralTab1, "vbxGeneralTab1");

  // Logon Frame Widgets
  HOOKUP_OBJECT (frmConnect, frameLogon, "frameLogon");
  HOOKUP_OBJECT (frmConnect, lblLogonFrame, "lblLogonFrame");
  HOOKUP_OBJECT (frmConnect, tblLogon0, "tblLogon0");
  HOOKUP_OBJECT (frmConnect, tblLogon1, "tblLogon1");
  HOOKUP_OBJECT (frmConnect, lblLogonNote, "lblLogonNote");
  HOOKUP_OBJECT (frmConnect, imgGeneralLogon, "imgGeneralLogon");
  HOOKUP_OBJECT (frmConnect, lblComputer, "lblComputer");
  HOOKUP_OBJECT (frmConnect, cboComputer, "cboComputer");
  HOOKUP_OBJECT (frmConnect, txtComputer, "txtComputer");
  HOOKUP_OBJECT (frmConnect, lblProtocol, "lblProtocol");
  HOOKUP_OBJECT (frmConnect, optProtocol, "optProtocol");
  HOOKUP_OBJECT (frmConnect, mnuProtocol, "mnuProtocol");
  HOOKUP_OBJECT (frmConnect, lblUsername, "lblUsername");
  HOOKUP_OBJECT (frmConnect, txtUsername, "txtUsername");
  HOOKUP_OBJECT (frmConnect, lblPassword, "lblPassword");
  HOOKUP_OBJECT (frmConnect, txtPassword, "txtPassword");
  HOOKUP_OBJECT (frmConnect, lblDomain, "lblDomain");
  HOOKUP_OBJECT (frmConnect, txtDomain, "txtDomain");
  HOOKUP_OBJECT (frmConnect, lblClientHostname, "lblClientHostname");
  HOOKUP_OBJECT (frmConnect, txtClientHostname, "txtClientHostname");
  HOOKUP_OBJECT (frmConnect, lblProtoFile, "lblProtoFile");
  HOOKUP_OBJECT (frmConnect, hbxProtoFile, "hbxProtoFile");
  HOOKUP_OBJECT (frmConnect, txtProtoFile, "txtProtoFile");
  HOOKUP_OBJECT (frmConnect, btnProtoFile, "btnProtoFile");

  // Profile Launcher Widgets
  HOOKUP_OBJECT (frmConnect, hbxProfileLauncher, "hbxProfileLauncher");
  HOOKUP_OBJECT (frmConnect, optProfileLauncher, "optProfileLauncher");
  // Profile File Ops Widgets
  HOOKUP_OBJECT (frmConnect, hbxFileOps, "hbxFileOps");
  HOOKUP_OBJECT (frmConnect, btnSaveAs, "btnSaveAs");
  HOOKUP_OBJECT (frmConnect, btnOpen, "btnOpen");

  // Display Tab Widgets
  HOOKUP_OBJECT (frmConnect, lblDisplayTab1, "lblDisplayTab1");
  HOOKUP_OBJECT (frmConnect, vbxDisplayTab1, "vbxDisplayTab1");

  // Size Frame Widgets
  HOOKUP_OBJECT (frmConnect, frameSize, "frameSize");
  HOOKUP_OBJECT (frmConnect, lblSizeFrame, "lblSizeFrame");
  HOOKUP_OBJECT (frmConnect, hbxSize, "hbxSize");
  HOOKUP_OBJECT (frmConnect, imgSize, "imgSize");
  HOOKUP_OBJECT (frmConnect, vbxSize, "vbxSize");
  HOOKUP_OBJECT (frmConnect, optSize1, "optSize1");
  HOOKUP_OBJECT (frmConnect, optSize2, "optSize2");
  HOOKUP_OBJECT (frmConnect, alnSize, "alnSize");
  HOOKUP_OBJECT (frmConnect, optSize, "optSize");
  HOOKUP_OBJECT (frmConnect, optSize3, "optSize3");
  HOOKUP_OBJECT (frmConnect, alnAltFullSwitch, "alnAltFullSwitch");
  HOOKUP_OBJECT (frmConnect, chkAltFullSwitch, "chkAltFullSwitch");

  // Color Frame Widgets
  HOOKUP_OBJECT (frmConnect, frameColor, "frameColor");
  HOOKUP_OBJECT (frmConnect, lblColorFrame, "lblColorFrame");
  HOOKUP_OBJECT (frmConnect, hbxColor, "hbxColor");
  HOOKUP_OBJECT (frmConnect, imgColor, "imgColor");
  HOOKUP_OBJECT (frmConnect, vbxColor, "vbxColor");
  HOOKUP_OBJECT (frmConnect, optColor1, "optColor1");
  HOOKUP_OBJECT (frmConnect, optColor2, "optColor2");
  HOOKUP_OBJECT (frmConnect, alnColor, "alnColor");
  HOOKUP_OBJECT (frmConnect, optColor, "optColor");

  // Local Resources Tab Widgets
  HOOKUP_OBJECT (frmConnect, lblLocalTab1, "lblLocalTab1");
  HOOKUP_OBJECT (frmConnect, vbxLocalTab1, "vbxLocalTab1");

  // Sound Frame Widgets
  HOOKUP_OBJECT (frmConnect, frameSound, "frameSound");
  HOOKUP_OBJECT (frmConnect, lblSoundFrame, "lblSoundFrame");
  HOOKUP_OBJECT (frmConnect, tblSound, "tblSound");
  HOOKUP_OBJECT (frmConnect, imgSound, "imgSound");
  HOOKUP_OBJECT (frmConnect, vbxSound, "vbxSound");
  HOOKUP_OBJECT (frmConnect, optSound1, "optSound1");
  HOOKUP_OBJECT (frmConnect, optSound2, "optSound2");
  HOOKUP_OBJECT (frmConnect, optSound3, "optSound3");

  // Keyboard Frame Widgets
  HOOKUP_OBJECT (frmConnect, frameKeyboard, "frameKeyboard");
  HOOKUP_OBJECT (frmConnect, lblKeyboardFrame, "lblKeyboardFrame");
  HOOKUP_OBJECT (frmConnect, tblKeyboard, "tblKeyboard");
  HOOKUP_OBJECT (frmConnect, lblKeyboard, "lblKeyboard");
  HOOKUP_OBJECT (frmConnect, optKeyboard, "optKeyboard");
  HOOKUP_OBJECT (frmConnect, mnuKeyboard, "mnuKeyboard");
  HOOKUP_OBJECT (frmConnect, miKeyboard, "miKeyboard");
  HOOKUP_OBJECT (frmConnect, lblKeyboardLang, "lblKeyboardLang");
  HOOKUP_OBJECT (frmConnect, cboKeyboardLang, "cboKeyboardLang");
  HOOKUP_OBJECT (frmConnect, txtKeyboardLang, "txtKeyboardLang");
  HOOKUP_OBJECT (frmConnect, imgKeyboard, "imgKeyboard");


  // Program Tab Widgets
  HOOKUP_OBJECT (frmConnect, lblProgramsTab1, "lblProgramsTab1");

  // Program Frame Widgets
  HOOKUP_OBJECT (frmConnect, frameProgram, "frameProgram");
  HOOKUP_OBJECT (frmConnect, lblProgramFrame, "lblProgramFrame");
  HOOKUP_OBJECT (frmConnect, tblProgram, "tblProgram");
  HOOKUP_OBJECT (frmConnect, chkStartProgram, "chkStartProgram");
  HOOKUP_OBJECT (frmConnect, imgProgram, "imgProgram");
  HOOKUP_OBJECT (frmConnect, lblProgramPath, "lblProgramPath");
  HOOKUP_OBJECT (frmConnect, txtProgramPath, "txtProgramPath");
  HOOKUP_OBJECT (frmConnect, lblStartFolder, "lblStartFolder");
  HOOKUP_OBJECT (frmConnect, txtStartFolder, "txtStartFolder");

  // Performance Tab Widgets
  HOOKUP_OBJECT (frmConnect, lblPerformanceTab1, "lblPerformanceTab1");

  // Performance Frame Widgets
  HOOKUP_OBJECT (frmConnect, framePerform, "framePerform");
  HOOKUP_OBJECT (frmConnect, lblPerformFrame, "lblPerformFrame");
  HOOKUP_OBJECT (frmConnect, tblPerform, "tblPerform");
  HOOKUP_OBJECT (frmConnect, imgPerform, "imgPerform");
  HOOKUP_OBJECT (frmConnect, lblPerformanceOptions, "lblPerformanceOptions");
  HOOKUP_OBJECT (frmConnect, vbxExpChecks, "vbxExpChecks");
  HOOKUP_OBJECT (frmConnect, chkDesktopBackground, "chkDesktopBackground");
  HOOKUP_OBJECT (frmConnect, chkWindowContent, "chkWindowContent");
  HOOKUP_OBJECT (frmConnect, chkAnimation, "chkAnimation");
  HOOKUP_OBJECT (frmConnect, chkThemes, "chkThemes");
  HOOKUP_OBJECT (frmConnect, chkBitmapCache, "chkBitmapCache");
  HOOKUP_OBJECT (frmConnect, chkNoMotionEvents, "chkNoMotionEvents");
  HOOKUP_OBJECT (frmConnect, chkEnableWMKeys, "chkEnableWMKeys");
  HOOKUP_OBJECT (frmConnect, chkHideWMDecorations, "chkHideWMDecorations");
  HOOKUP_OBJECT (frmConnect, chkAttachToConsole, "chkAttachToConsole");

  // Complete Button Box Widgets
  HOOKUP_OBJECT (frmConnect, hbbAppOps, "hbbAppOps");
  HOOKUP_OBJECT (frmConnect, btnConnect, "btnConnect");
  HOOKUP_OBJECT (frmConnect, alnConnect, "alnConnect");
  HOOKUP_OBJECT (frmConnect, hbxConnect, "hbxConnect");
  HOOKUP_OBJECT (frmConnect, imgConnect, "imgConnect");
  HOOKUP_OBJECT (frmConnect, lblConnect, "lblConnect");
  HOOKUP_OBJECT (frmConnect, btnQuit, "btnQuit");
  HOOKUP_OBJECT (frmConnect, btnHelp, "btnHelp");

  // disable the keyboard opts until they are supported
  gtk_widget_set_sensitive (optKeyboard, FALSE);

  // toggle the start program thingy to false.  will be set after this by loading.
  gtk_toggle_button_set_active ((GtkToggleButton*) chkStartProgram, FALSE);
  gtk_widget_set_sensitive (txtProgramPath, FALSE);
  gtk_widget_set_sensitive (txtStartFolder, FALSE);
  
  gtk_widget_set_sensitive (alnSize, FALSE);
  gtk_toggle_button_set_active ((GtkToggleButton*) chkAltFullSwitch, FALSE);
  gtk_widget_set_sensitive (alnAltFullSwitch, FALSE);
  gtk_widget_set_sensitive (alnColor, FALSE);

  gtk_widget_show_all (frmConnect);

  // load mru & profile launcher
  mru_to_screen (frmConnect);
  rdp_load_profile_launcher (frmConnect);

  gtk_widget_hide (chkDesktopBackground);
  gtk_widget_hide (chkWindowContent);
  gtk_widget_hide (chkAnimation);
  gtk_widget_hide (chkThemes);

  gConnect = frmConnect;

  //return frmConnect;
  return 0;
}


/***************************************
*                                      *
*   Event Handlers                     *
*                                      *
***************************************/


void
on_btnConnect_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;
  rdp_file *rdp = NULL;
  gchar *home = tsc_home_path ();
  gchar *filename = g_build_path ("/", home, "last.tsc", NULL);

  #ifdef TSCLIENT_DEBUG
  printf ("on_btnConnect_clicked\n");
  #endif

  main_window = lookup_widget((GtkWidget*)button, "frmConnect");

  rdp = g_new0 (rdp_file, 1);
  rdp_file_init (rdp);
  rdp_file_get_screen (rdp, main_window);
  // save the damn thing as last
  rdp_file_save (rdp, filename);

  gtk_widget_hide (main_window);
  gtk_widget_destroy (main_window);

  gchar** error = g_malloc(sizeof(gchar*));

  if (tsc_launch_remote (rdp, 0, error) == 0) {
    mru_add_server (rdp->full_address);
  } else {
    tsc_connect_error (rdp,*error);
  }
  if(*error)
      g_free(*error);
  g_free(error);

  // recreate the main window
  create_frmConnect ();
  rdp_file_set_screen (rdp, gConnect);
  g_free (rdp);

  g_free (filename);
  g_free (home);
}


void
on_btnQuit_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;
  rdp_file *rdp_last = NULL;
  gchar *home = tsc_home_path ();
  gchar *filename = g_build_path ("/", home, "last.tsc", NULL);

  #ifdef TSCLIENT_DEBUG
  printf ("on_btnQuit_clicked\n");
  #endif

  main_window = gConnect;
  gtk_widget_hide (main_window);

  // save the damn thing
  rdp_last = g_new0 (rdp_file, 1);
  rdp_file_init (rdp_last);
  rdp_file_get_screen (rdp_last, main_window);
  rdp_file_save (rdp_last, filename);
  g_free (rdp_last);

  g_free (filename);
  g_free (home);

  gtk_main_quit();
}


void
on_btnHelp_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  tsc_about_dialog ();
}


void
on_optSize1_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *aln_size, *aln_afss;

  aln_size = lookup_widget (gConnect, "alnSize");
  aln_afss = lookup_widget (gConnect, "alnAltFullSwitch");
  
  gtk_widget_set_sensitive (aln_size, FALSE);
  gtk_widget_set_sensitive (aln_afss, FALSE);
}


void
on_optSize2_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *aln_size, *aln_afss;

  aln_size = lookup_widget (gConnect, "alnSize");
  aln_afss = lookup_widget (gConnect, "alnAltFullSwitch");
  gtk_widget_set_sensitive (aln_size, TRUE);
  gtk_widget_set_sensitive (aln_afss, FALSE);
}


void
on_optSize3_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *aln_size, *aln_afss;

  aln_size = lookup_widget (gConnect, "alnSize");
  aln_afss = lookup_widget (gConnect, "alnAltFullSwitch");
  gtk_widget_set_sensitive (aln_size, FALSE);
  gtk_widget_set_sensitive (aln_afss, TRUE);
}


void
on_optColor1_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *aln_color;

  aln_color = lookup_widget (gConnect, "alnColor");
  gtk_widget_set_sensitive (aln_color, FALSE);
}


void
on_optColor2_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *aln_color;

  aln_color = lookup_widget (gConnect, "alnColor");
  gtk_widget_set_sensitive (aln_color, TRUE);
}

void
on_btnSaveAs_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *save_selector = NULL;
  GtkWidget *main_window;
  rdp_file *rdp = NULL;
  GtkFileFilter *filter;

  main_window = lookup_widget((GtkWidget *)button, "frmConnect");

  save_selector = gtk_file_chooser_dialog_new (_("Input a filename to save as..."), 
    GTK_WINDOW(main_window), GTK_FILE_CHOOSER_ACTION_SAVE,
	GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
	GTK_STOCK_OK, GTK_RESPONSE_OK,
	NULL);
  gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(save_selector), tsc_home_path ());

  filter = gtk_file_filter_new ();
  gtk_file_filter_set_name (filter, _("RDP Files"));
  gtk_file_filter_add_pattern (filter, "*.rdp");
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(save_selector), filter);
  gtk_file_chooser_set_filter (GTK_FILE_CHOOSER(save_selector), filter);

  filter = gtk_file_filter_new ();
  gtk_file_filter_set_name (filter, _("All Files"));
  gtk_file_filter_add_pattern (filter, "*");
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(save_selector), filter);
  
  if (gtk_dialog_run (GTK_DIALOG(save_selector)) == GTK_RESPONSE_OK) {
    gchar *filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER(save_selector));
    if (filename) {
      GtkWidget *mi;
	  char *home = tsc_home_path ();
      // Add our extension if needed
	  char *lastdelim = g_strrstr (filename, "/");
      if (lastdelim && g_strrstr (lastdelim + 1, ".") == NULL) {
	    char *tmp = g_strconcat (filename, ".rdp", NULL);
		g_free (filename);
		filename = tmp;
      }
      #ifdef TSCLIENT_DEBUG
      printf ("filename: %s\n", filename);
      #endif
      // save rdp file
      rdp = g_new0 (rdp_file, 1);
      rdp_file_init (rdp);
      rdp_file_get_screen (rdp, main_window);
      rdp_file_save (rdp, filename);
      g_free (rdp);
      // Add to quick pick list
	  lastdelim = g_strrstr (filename, tsc_home_path ());
	  if (lastdelim) {
        GtkWidget *opt = lookup_widget (main_window, "optProfileLauncher");
 	    lastdelim += strlen (home) + 1;
	gtk_combo_box_append_text (GTK_COMBO_BOX (opt), lastdelim);
	  }
	  // Try to avoid *some* memory leaks
      g_free (filename);
	  g_free (home);
    }
  }
  gtk_widget_destroy (GTK_WIDGET(save_selector));
  return;
}


void
on_btnOpen_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *open_selector = NULL;
  GtkFileFilter *filter;
  GtkWidget *main_window;
  rdp_file *rdp = NULL;

  main_window = lookup_widget((GtkWidget *)button, "frmConnect");

  open_selector = gtk_file_chooser_dialog_new (_("Choose a RDP file to open..."), 
    GTK_WINDOW(main_window), GTK_FILE_CHOOSER_ACTION_OPEN,
	GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
	GTK_STOCK_OK, GTK_RESPONSE_OK,
	NULL);
  gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(open_selector), tsc_home_path ());

  filter = gtk_file_filter_new ();
  gtk_file_filter_set_name (filter, _("RDP Files"));
  gtk_file_filter_add_pattern (filter, "*.rdp");
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(open_selector), filter);
  gtk_file_chooser_set_filter (GTK_FILE_CHOOSER(open_selector), filter);
  
  if (gtk_dialog_run (GTK_DIALOG(open_selector)) == GTK_RESPONSE_OK) {
    gchar *filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER(open_selector));
    if (filename) {
      #ifdef TSCLIENT_DEBUG
      printf ("filename: %s\n", filename);
      #endif
      // check if the file exists
      if (g_file_test (filename, G_FILE_TEST_EXISTS)) {
        // load if exists
        rdp = g_new0 (rdp_file, 1);
        rdp_file_init (rdp);
        rdp_file_load (rdp, filename);
        rdp_file_set_screen (rdp, main_window);
        g_free (rdp);
        g_free (filename);
      }
    }
  }
  gtk_widget_destroy (GTK_WIDGET(open_selector));
  return;
}


void
on_btnProtoFile_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *open_selector = NULL;
  GtkWidget *main_window, *proto_file;
  gchar *home = tsc_home_path ();
  guint pos = 0;

  open_selector = gtk_file_selection_new ("Select File");
  gtk_container_set_border_width (GTK_CONTAINER (open_selector), 12);
  gtk_window_set_position (GTK_WINDOW (open_selector), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (open_selector), TRUE);
  gtk_window_set_destroy_with_parent (GTK_WINDOW (open_selector), TRUE);
  gtk_window_set_title ((GtkWindow*) open_selector, _("Choose an RDP file to open..."));
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (open_selector));
  gtk_file_selection_set_select_multiple (GTK_FILE_SELECTION (open_selector), FALSE);
  gtk_window_set_icon (GTK_WINDOW (open_selector), create_pixbuf ("tsclient.png"));
  gtk_widget_grab_default (GTK_FILE_SELECTION (open_selector)->ok_button);
  gtk_file_selection_set_filename (GTK_FILE_SELECTION (open_selector), home);

  if (gtk_dialog_run (GTK_DIALOG (open_selector)) == GTK_RESPONSE_OK) {
    gchar *filename = (gchar *)gtk_file_selection_get_filename (GTK_FILE_SELECTION (open_selector));
    if (filename) {
      #ifdef TSCLIENT_DEBUG
      printf ("filename: %s\n", filename);
      #endif
      main_window = lookup_widget((GtkWidget*)button, "frmConnect");
      proto_file = lookup_widget((GtkWidget*)main_window, "txtProtoFile");
      gtk_editable_delete_text ((GtkEditable*) proto_file, 0, -1);
      gtk_editable_insert_text((GtkEditable*) proto_file, filename, strlen(filename), &pos);
    }
  }
  gtk_widget_destroy (GTK_WIDGET (open_selector));

  g_free (home);
  return;
}


void
on_chkStartProgram_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  GtkWidget *txtProgramPath, *txtStartFolder;
  txtProgramPath = lookup_widget (GTK_WIDGET (gConnect), "txtProgramPath");
  txtStartFolder = lookup_widget (GTK_WIDGET (gConnect), "txtStartFolder");

  if (gtk_toggle_button_get_active (togglebutton)) {
    gtk_widget_set_sensitive (txtProgramPath, TRUE);
    gtk_widget_set_sensitive (txtStartFolder, TRUE);
  } else {
    gtk_widget_set_sensitive (txtProgramPath, FALSE);
    gtk_widget_set_sensitive (txtStartFolder, FALSE);
  }
}


void
on_protocol_changed (GtkMenuItem *menuitem, gpointer user_data)
{
  GtkWidget *main_win;
  main_win = lookup_widget (GTK_WIDGET (menuitem), "frmConnect");
  tsc_set_protocol_widgets (main_win, (gint)user_data);
}

